program plConvertHLPtoHTML;

uses
  Vcl.Forms,
  System.StrUtils,
  System.SysUtils,
  Winapi.Windows,
  plConvertHLPtoHTMLUnit in 'plConvertHLPtoHTMLUnit.pas' {MainForm};

{$R *.res}

var
  LMsgText : string;

function IsValidPathName(APathName: string): Boolean;
var
  LAnsiStr  : AnsiString;
  LAnsiChar : AnsiChar;
  LIndex    : Integer;
begin
  Result := False;

  if ContainsText(APathName, '@') then begin
    Result := True;
    Exit;
  end;

  LAnsiStr := AnsiString(APathName);
  for LIndex := 1 to Length(APathName) do begin
    LAnsiChar := LAnsiStr[LIndex];
    if (LAnsiChar in LeadBytes) or (LAnsiChar = ' ') then begin
      Result := True;
      Break;
    end;
  end;
end;

begin
  if IsValidPathName(ParamStr(0)) then begin
    LMsgText := '{vŐNꏊ' + sLineBreak + sLineBreak
              + 'pXɑSp܂͋󔒕܂' + sLineBreak
              + '̕Ɛɏł܂' + sLineBreak
              + 'vŐN𒆎~܂';
    MessageBox(0, PChar(LMsgText), 'HLP wv CHM wvɕϊ鏈', MB_ICONWARNING);
  end else begin
    Application.Initialize;
    Application.MainFormOnTaskbar := True;
    Application.CreateForm(TMainForm, MainForm);
    Application.Run;
  end;
end.
