{$WARNINGS OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  HLP `̃wv ChM `̃wvt@Cɕϊ
//  𓀐p\tg Universal Extractor  HTML Help Workshop 𗘗p
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2019N0301 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plConvertHLPtoHTMLUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Vcl.AppEvnts, Vcl.Buttons, Vcl.ComCtrls,
  System.Win.ComObj, Vcl.Menus;

type
  TMainForm = class(TForm)
    FileOpenDialog1: TFileOpenDialog;
    ApplicationEvents1: TApplicationEvents;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton4Click(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure Panel1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FIniFilePath       : string;
    FOldCharset        : string;
    FNewCharset        : string;
    FUExtractorExePath : string;
    FHHWorkshopExePath : string;
    FHMachineExePath   : string;
    FShortCut          : TShortCut;
    function GetHMachineIniFilePath(AExePath: string): string;
    function GetHMachineExePathfromVirtualStore: string;
    function CheckItemsCount(var ACntPath: string; ATocPath: string): Integer;
    function ChangeCharSetETC(ADir, AOldValue, ANewValue: string): Integer;
    function Create_hhcFile(AHtmlDir, ACntFilePath: string; var AOriginItemCnt: Integer;
      var AItemCnt: Integer; var AHeaderCnt: Integer; ADupeList: TStringList): Boolean;
    function Create_hhkFile(AHtmlDir: string; ACntFilePath: string;
      AFullKeywords: Boolean): Integer;
    function CreateHelpMachineXHP(AXHPPath: string): Boolean;
    function CreateHHWorkshopHHP(AProjPath: string): Boolean;
    function RemotHHCWindow(AHPJPath: string; AHHPPath: string): Boolean;
    function RemotHelpMachine(AXHPPath: string; AhhcPath: string): Boolean;
  end;

function Is64bitWindows: Boolean;
function GetRelatedFullExePath(ExtName: string): string;
function GetInstalledAppDir(AppNameStr: string): string;
function RunExeFile(hWnd: HWND; AFile: string; AParameters: string;
  Verb: string; IsWaitQuit: Boolean; ISHHWShow: Boolean): Cardinal;
procedure SetPositionSize(AWnd: HWND; IsRestore: Boolean; IsHIDE: Boolean);
procedure SendCtrlKeys(hWindow: HWND; ACmdStr: string);
function GetWindowClassNameStr(hWindow: HWND): String;
function EnumWindowsProcEx(hWindow: HWND; lPalam: PNativeInt): Boolean; stdcall;
function EnumChildWindowsProcEx(hWindow: HWND; lPalam: PNativeInt): Boolean; stdcall;
function GetEnvironmentPath(AEnvName: string): string;
function DeleteResistryFileExt(RegistFileExt: String): Boolean;

var
  MainForm: TMainForm;

implementation

uses
  Generics.Collections,
  Winapi.ShellAPI,
  Winapi.ShlObj,
  System.Types,
  System.Win.Registry,
  System.IOUtils,
  System.StrUtils,
  Winapi.MMSystem,
  System.IniFiles,
  Winapi.ShLwApi,
  System.Math,
  System.Masks,
  plCommandRedirect;

{$R *.dfm}

var
  FOriginPlace : TWindowPlacement;
  FWorkshopWnd : HWND;
  FHMachineWnd : HWND;
  FTargetID    : Integer;

//=============================================================================
//  tH[̏
//=============================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
  LIniFile    : TMemIniFile;
  LFuncFilter : function (msg: Cardinal; dwFlag: DWORD): BOOL; stdcall;
  LDLLHandle  : THandle;
begin
  ActiveControl := Button1;
  PageControl1.ActivePageIndex := 0;
  Caption := 'HLP wv CHM wvɕϊ鏈';
  Label5.Caption := '';

  FOldCharset := 'charset=Windows-1252';

  FIniFilePath := ChangeFileExt(Application.ExeName, '.ini');
  LIniFile := TMemIniFile.Create(FIniFilePath);
  try
    Left := LIniFile.ReadInteger('MAIN', 'Left',0);
    Top  := LIniFile.ReadInteger('MAIN', 'Top',0);
    FUExtractorExePath := LIniFile.ReadString('MAIN', 'UExtractorExePath', '');
    FHHWorkshopExePath := LIniFile.ReadString('MAIN', 'HHWorkshopExePath', '');
    FHMachineExePath   := LIniFile.ReadString('MAIN', 'HMachineExePath','');
    Edit4.Text := LIniFile.ReadString('MAIN', 'HLPFilePath', '');
    FNewCharset := LIniFile.ReadString('MAIN', 'Charset', 'shift_jis');
  finally
    FreeAndNil(LIniFile);
  end;

  if (Left = 0) and (Top = 0) then begin
    Position := poMainFormCenter;
  end else begin
    Position := poDesigned;
  end;

  if (FHMachineExePath = '') and (FHHWorkshopExePath = '') then begin
    FHMachineExePath := GetRelatedFullExePath('.XHP');
    if FHMachineExePath = ''then begin
      FHMachineExePath := GetHMachineExePathfromVirtualStore;
    end;
  end;
  if FHHWorkshopExePath = '' then begin
    FHHWorkshopExePath := GetInstalledAppDir('HTML Help Workshop');
    if FHHWorkshopExePath <> '' then begin
      FHHWorkshopExePath := TPath.Combine(FHHWorkshopExePath, 'hhw.exe');
    end;
  end;

  Edit1.Text := FUExtractorExePath;
  Edit2.Text := FHHWorkshopExePath;
  Edit3.Text := FHMachineExePath;

  DragAcceptFiles(Edit1.Handle, True);
  DragAcceptFiles(Edit2.Handle, True);
  DragAcceptFiles(Edit3.Handle, True);
  DragAcceptFiles(Edit4.Handle, True);

  if CheckWin32Version(6, 0) then begin
    LDLLHandle := loadLibrary('user32.dll');
    try
      if LDLLHandle > 0 then begin
        @LFuncFilter := GetProcAddress(LDLLHandle, 'ChangeWindowMessageFilter');
        if @LFuncFilter <> nil then begin
          LFuncFilter(WM_DROPFILES,      MSGFLT_ADD);
          LFuncFilter(WM_COPYDATA,       MSGFLT_ADD);
          LFuncFilter(WM_COPYGLOBALDATA, MSGFLT_ADD);
        end;
      end;
    finally
      FreeLibrary(LDLLHandle);
    end;
  end;

  FShortCut := TextToShortCut('Ctrl+Del');

  if ParamCount = 1 then begin
    Edit4.Text := Trim(ParamStr(1));
    Self.Show;
    Button1Click(nil);
  end;
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  LIniFile : TMemIniFile;
begin
  Position := poDesigned;

  FUExtractorExePath := Edit1.Text;
  FHHWorkshopExePath := Edit2.Text;
  FHMachineExePath   := Edit3.Text;

  LIniFile := TMemIniFile.Create(FIniFilePath);
  try
    LIniFile.WriteInteger('MAIN', 'Left',Left);
    LIniFile.WriteInteger('MAIN', 'Top',Top);
    LIniFile.WriteString('MAIN', 'UExtractorExePath', FUExtractorExePath);
    LIniFile.WriteString('MAIN', 'HHWorkshopExePath', FHHWorkshopExePath);
    LIniFile.WriteString('MAIN', 'HMachineExePath',FHMachineExePath);
    LIniFile.WriteString('MAIN', 'HLPFilePath', Trim(Edit4.Text));
    LIniFile.WriteString('MAIN', 'Charset', FNewCharset);
    LIniFile.UpdateFile;
  finally
    FreeAndNil(LIniFile);
  end;

  FHMachineWnd := FindWindow(nil, 'wv܂');
  if FHMachineWnd <> 0 then begin
    SetForegroundWindow(FHMachineWnd);
  end;
end;

//=============================================================================
//  ϊJn
//  Ɏs\ݒ`FbNĂ珈Jn
//=============================================================================
procedure TMainForm.Button1Click(Sender: TObject);
var
  LKeyState       : TKeyboardState;
  LDlgMBFlag      : Cardinal;
  LShowWorkshop   : Boolean;
  LSrcHLPFilePath : string;
  LHLPFilePath    : string;
  LChmFileName    : string;
  LhhcExePath     : string;
  LCntFilePath    : string;
  LTocFilePath    : string;
  LDecompileDir   : string;
  LWorkshopDir    : string;
  LMsgText        : string;
  LIniFile        : TMemIniFile;
  LHMachineIniPath: string;
  LHMachineDir    : string;
  LHMachineResDir : string;
  LTempText       : string;
  LOriginItemCnt  : Integer;
  LHPJFilePath    : string;
  LHHPFilePath    : string;
  LXHPFilePath    : string;
  LCommandLine    : string;
  LFileDir        : string;
  LDupeList       : TStringList;
  LCount          : Integer;
  LHtmlDir        : string;
  LItemCnt        : Integer;
  LHeaderCnt      : Integer;
  LDupeItemFile   : string;
  LFilesList      : TStringDynArray;
  LVirtualStore   : Boolean;
  LTimeValue      : Cardinal;
  LTimeSec        : Cardinal;
  LTimeMin        : Cardinal;
  LErrorFlag      : Boolean;
begin
  Button1.Enabled := False;
  Label5.Caption := '`FbNEEE';

  // ̃vO̍҂̃fobOp
  if GetKeyboardState(LKeyState) then begin
    LShowWorkshop := LKeyState[VK_CONTROL] and $80 <> 0;
    if LKeyState[VK_SHIFT] and $80 <> 0 then begin
      LDlgMBFlag := MB_ICONINFORMATION;
    end else begin
      LDlgMBFlag := MB_TOPMOST or MB_ICONINFORMATION;
    end;
  end;

  LVirtualStore := GetRelatedFullExePath('.XHP') = '';

  FUExtractorExePath := Trim(Edit1.Text);
  FHHWorkshopExePath := Trim(Edit2.Text);
  FHMachineExePath   := Trim(Edit3.Text);
  LSrcHLPFilePath    := Trim(Edit4.Text);
  LhhcExePath        := ExtractFilePath(FHHWorkshopExePath) + 'hhc.exe';

  LDecompileDir := ExtractFilePath(Application.ExeName) + 'HLPDecompile';
  LWorkshopDir  := ExtractFilePath(Application.ExeName) + 'HelpWorkshop';

  FWorkshopWnd := FindWindow('hhw_class', nil);
  FHMachineWnd := FindWindow(nil, 'wv܂');
  try
    if FWorkshopWnd <> 0 then begin
      LMsgText := 'HTML Help Workshoe Nł' + sLineBreak
                + 'Ă';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;
    if FHMachineWnd <> 0 then begin
      LMsgText := 'wv܂񂪋Nł' + sLineBreak
                + 'Ă';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if not FileExists(FUExtractorExePath) then begin
      LMsgText := 'Universal Extractor' + sLineBreak
                + 'w肵 EXE t@C܂' + sLineBreak + '𒆎~܂';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if not FileExists(FHHWorkshopExePath) then begin
      LMsgText := 'HTML Help Workshop' + sLineBreak
                + 'w肵 EXE t@C܂' + sLineBreak + '𒆎~܂';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if FHMachineExePath <> '' then begin
      if not FileExists(FHMachineExePath) then begin
        LMsgText := 'wv܂' + sLineBreak + sLineBreak
                  + 'w肵 EXE t@C܂' + sLineBreak + '𒆎~܂';
        MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
        Exit;
      end else begin
        LHMachineIniPath := GetHMachineIniFilePath(FHMachineExePath);
        LIniFile := TMemIniFile.Create(LHMachineIniPath);
        try
          LHMachineDir := LIniFile.ReadString('SYSTEM', 'PROJECT', '');
          LTempText    := LIniFile.ReadString('SYSTEM', 'HHC', '');
        finally
          FreeAndNil(LIniFile);
        end;

        if (LHMachineDir <> '') and ContainsText(LHMachineDir, 'Program Files') then begin
          LMsgText := 'wv܂̃vWFNgfBNg' + sLineBreak + sLineBreak
                    + 'Program Files VXe֌W̃tH_' + sLineBreak + sLineBreak
                    + '̃tH_̃t@Cނ͐ɏł܂' + sLineBreak
                    + '̃tH_w肵Ă';
          MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
          Exit;
        end else begin
          if not DirectoryExists(LHMachineDir) then begin
            LMsgText := 'wv܂̃vWFNgfBNg' + sLineBreak
                      + 'w肵fBNg܂';
            MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
            Exit;
          end;
        end;
      end;
      if UpperCase(LhhcExePath) <> UpperCase(LTempText) then begin
        LMsgText := 'wv܂̐ݒ' + sLineBreak
                  + 'HTML Help RpCݒ肳Ă܂';
        MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
        Exit;
      end;
    end;

    if UpperCase(ExtractFileExt(LSrcHLPFilePath)) <> '.HLP' then begin
      LMsgText := 't@C̎w' + sLineBreak
                + 'HLP t@Cw肵Ă';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if not FileExists(LSrcHLPFilePath) then begin
      LMsgText := 'HLP t@C' + sLineBreak
                + 'w肵 HLP t@C܂';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if FileExists(LSrcHLPFilePath) then begin
      LCntFilePath := ChangeFileExt(LSrcHLPFilePath, '.cnt');
      LTocFilePath := ChangeFileExt(LSrcHLPFilePath, '.toc');
      if not FileExists(LCntFilePath) then LCntFilePath := '';
      if not FileExists(LTocFilePath) then LTocFilePath := '';

      if (LCntFilePath = '') and (LTocFilePath = '') then begin
        LMsgText := 'HLP ֌Wt@C' + sLineBreak + sLineBreak
                  + ' HLP ɂ CNT ܂ TOC t@C܂' + sLineBreak
                  + '̃t@CȂ CHM t@Cɕϊł܂';
        MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
        Exit;
      end;

      LOriginItemCnt := CheckItemsCount(LCntFilePath, LTocFilePath);
      if LOriginItemCnt = 0 then begin
        LMsgText := 'HLP ֌Wt@C' + sLineBreak + sLineBreak
                  + ' HLP ɂ͖ڎACeɑLq܂' + sLineBreak
                  + 'CHM t@Cɕϊł܂';
        MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
        Exit;
      end;
    end;
  finally
    Button1.Enabled := True;
    Label5.Caption  := '';
  end;
  // Exit  finally sꂽꍇ,͎sȂ
  
  //------------- t@C֌W̃`FbNI --------------
  
  Button1.Enabled := False;
  Screen.Cursor   := crHourGlass;
  LTimeValue      := timeGetTime;

  try
    LErrorFlag := True;
  
    if DirectoryExists(LDecompileDir) then begin
      TDirectory.Delete(LDecompileDir, True);
      Application.ProcessMessages;
      Sleep(1);
    end;
    TDirectory.CreateDirectory(LDecompileDir);

    if DirectoryExists(LWorkshopDir) then begin
      TDirectory.Delete(LWorkshopDir, True);
      Application.ProcessMessages;
      Sleep(1);
    end;
    TDirectory.CreateDirectory(LWorkshopDir);
  
    LHLPFilePath := TPath.Combine(LDecompileDir, ExtractFileName(LSrcHLPFilePath));
    TFile.Copy(LSrcHLPFilePath, LHLPFilePath, True);

    LTempText := TPath.Combine(LDecompileDir, ExtractFileName(LCntFilePath));
    TFile.Copy(LCntFilePath, LTempText,True);
    LCntFilePath := LTempText;

    LChmFileName := ChangeFileExt(ExtractFileName(LCntFilePath), '.chm');
    LHPJFilePath := ChangeFileExt(LHLPFilePath, '.HPJ');
    LHHPFilePath := TPath.Combine(LWorkshopDir, ChangeFileExt(LChmFileName, '.HHP'));

    Label5.Caption := 'tRpCEEE';
    ProgressBar1.Style := pbstMarquee;

    LCommandLine := AnsiQuotedStr(LHLPFilePath, '"') + ' ' + AnsiQuotedStr(LDecompileDir, '"');
    RunExeFile(0, FUExtractorExePath, LCommandLine, '', True, LShowWorkshop);

    Label5.Caption := 'HTML t@CEEE';

    if not FileExists(LHPJFilePath) then begin
      LMsgText := 'HPJ t@Cł܂ł' + sLineBreak
                + 'HTML t@C𐶐邱Ƃł܂' + sLineBreak
                + '𒆎~܂';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    if RunExeFile(0, FHHWorkshopExePath, '', '', False, LShowWorkshop) <= 32 then begin
      LMsgText := 'HLP t@C HTML t@C̐ ' + sLineBreak
                + 's܂';
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;

    while True do begin
      FWorkshopWnd := FindWindow('hhw_class', nil);
      if FWorkshopWnd <> 0 then begin
        if not LShowWorkshop then begin
          SetPositionSize(FWorkshopWnd, False, True);
        end;
        Break;
      end;
      Application.ProcessMessages;
      sleep(10);
    end;
    Sleep(100);
    if not RemotHHCWindow(LHPJFilePath, LHHPFilePath) then begin
      if not LShowWorkshop then begin
        SetPositionSize(FWorkshopWnd, True, True);
      end;
      PostMessage(FWorkshopWnd, WM_CLOSE, 0, 0);
      LMsgText := 'HLP t@C HTML t@C̐ ' + sLineBreak
                + 's܂';
      PostMessage(FWorkshopWnd, WM_CLOSE, 0, 0);
      MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
      Exit;
    end;
    Sleep(100);

    while True do begin
      if FileExists(LHHPFilePath) then Break;
      Application.ProcessMessages;
      sleep(10);
    end;
    if not LShowWorkshop then begin
      SetPositionSize(FWorkshopWnd, True, True);
    end;
    Sleep(500);
    PostMessage(FWorkshopWnd, WM_CLOSE, 0, 0);

    Label5.Caption := 'ڎACȅEEE';
    ProgressBar1.Style := pbstNormal;

    LHtmlDir      := TPath.Combine(LWorkshopDir, 'html');
    LDupeItemFile := TPath.Combine(LWorkshopDir,'DupeItemList.txt');

    LDupeList := TStringList.Create;
    try
      LCount := ChangeCharSetETC(LHtmlDir, FOldCharset, FNewCharset);@
      Create_hhcFile(LHtmlDir,
                     LCntFilePath,
                     LOriginItemCnt,
                     LItemCnt,
                     LHeaderCnt,
                     LDupeList);
      Create_hhkFile(LHtmlDir, LCntFilePath, FHMachineExePath = '');
      CreateHHWorkshopHHP(LHHPFilePath);
//
      if FHMachineExePath <> '' then begin
        Label5.Caption := 'wv܂̏EEE';
        Label5.Update;
        ProgressBar1.Style := pbstMarquee;
        ProgressBar1.Update;

        LHMachineDir    := TPath.Combine(LHMachineDir, ChangeFileExt(LChmFileName, ''));
        LXHPFilePath    := TPath.Combine(LHMachineDir, ChangeFileExt(LChmFileName, '.XHP'));
        LHMachineResDir := TPath.Combine(LHMachineDir, '_RESOURCE');
        while True do begin
          if not DirectoryExists(LHMachineDir) then Break;
          TDirectory.Delete(LHMachineDir, True);
          Application.ProcessMessages;
          Sleep(1);
        end;
        TDirectory.CreateDirectory(LHMachineDir);

        CreateHelpMachineXHP(LXHPFilePath);

        LFilesList := TDirectory.GetDirectories(ExtractFileDir(LHtmlDir));
        for LFileDir in LFilesList do begin
          TDirectory.Copy(LFileDir, TPath.Combine(LHMachineResDir, ExtractFileName(LFileDir)));
        end;
        Application.ProcessMessages;

        // wv܂Nď
        // wv܂NăRpC

        if RunExeFile(0, FHMachineExePath, AnsiQuotedStr(LXHPFilePath, '"'), '', False, True) <= 32 then begin
          LMsgText := 'wv}V̋N ' + sLineBreak
                    + 's܂';
          MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
          Exit;
        end;

        if not RemotHelpMachine(LXHPFilePath, ChangeFileExt(LHHPFilePath, '.hhc')) then begin
          PostMessage(FHMachineWnd, WM_CLOSE, 0, 0);
          LMsgText := 'wv}V̐ݒ ' + sLineBreak
                    + 's܂';
          PostMessage(FHMachineWnd, WM_CLOSE, 0, 0);
          MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
          Exit;
        end;
      end;


      if LDupeList.Count > 0 then begin
        LDupeList.SaveToFile(LDupeItemFile);
        LMsgText := sLineBreak + sLineBreak + 'mFKvȖڎACe܂' + sLineBreak
                  + ExtractFileName(LDupeItemFile) + ' \ĊmFĂ';
      end;
    finally
      FreeAndNil(LDupeList);
    end;

    if FHMachineExePath = '' then begin
      Label5.Caption := 'RpCEEE';
      ProgressBar1.Style := pbstMarquee;

      LCommandLine := AnsiQuotedStr(LHHPFilePath, '"');
      if RunExeFile(0, LhhcExePath, LCommandLine, '', True, LShowWorkshop) <= 32 then begin
        LMsgText := 'HTML t@C CHM t@C̍쐬 ' + sLineBreak
                  + 'RpCɎs܂';
        MessageBox(Handle, PChar(LMsgText), '~', MB_ICONWARNING);
        Exit;
      end;
    end;

    LErrorFlag := False;
  finally
    Label5.Caption := '㏈EEE';

    if DirectoryExists(LDecompileDir) then begin
      TDirectory.Delete(LDecompileDir, True);
      Application.ProcessMessages;
      Sleep(1);
    end;

    if FHMachineExePath <> '' then begin
      if DirectoryExists(LWorkshopDir) then begin
        TDirectory.Delete(LWorkshopDir, True);
        Application.ProcessMessages;
        Sleep(1);
      end;
    end;

    if LVirtualStore then begin
      if DeleteResistryFileExt('XHP') then begin
        DeleteResistryFileExt('XHC');
      end;
    end;

    Label5.Caption := '';
    Screen.Cursor := crDefault;
    Button1.Enabled := True;

    if LErrorFlag then begin
      Button1.SetFocus;
      ProgressBar1.Style    := pbstNormal;
      ProgressBar1.Position := 0;
    end else begin
      ProgressBar1.Style    := pbstNormal;
      ProgressBar1.Position := ProgressBar1.Max;
    end;
  end;
  // Exit  finally sꂽꍇ,͎sȂ
  // Ĉȉ͎̏ۂɂ͕sv

  if not LErrorFlag then begin
    LTimeValue := (timeGetTime - LTimeValue) div 1000;
    LTimeMin := LTimeValue div 60;
    LTimeSec := LTimeValue - LTimeMin * 60;
    if LTimeMin = 0 then begin
      if LTimeSec = 0 then begin
        LMsgText := '1 b' + LMsgText;
      end else begin
        LMsgText := IntToStr(LTimeSec) + ' b' + LMsgText;
      end;
    end else begin
      LMsgText := IntToStr(LTimeMin) + '  ' + IntToStr(LTimeSec) + ' b' + LMsgText;
    end;

    LMsgText := 'I܂' + sLineBreak + sLineBreak
              + 't@C : ' + IntToStr(LCount) + sLineBreak
              + 'ڎACe : ' + IntToStr(LItemCnt) + ' ( ' + IntToStr(LOriginItemCnt) + ' )'  + sLineBreak
              + 'wb_ACe : ' + IntToStr(LHeaderCnt) + sLineBreak
              + ' : ' + LMsgText;
    MessageBox(Handle, PChar(LMsgText), 'I', LDlgMBFlag);
  end;

  Button1.SetFocus;
  ProgressBar1.Style    := pbstNormal;
  ProgressBar1.Position := 0;
end;

//=============================================================================
//  Universal Extractor (fRpCpAv)  EXE pX̎w
//=============================================================================
procedure TMainForm.SpeedButton1Click(Sender: TObject);
var
  LText : string;
begin
  FileOpenDialog1.Options := [fdoForceFileSystem];
  LText := Trim(Edit1.Text);
  if LText <> '' then begin
    if DirectoryExists(ExtractFileDir(LText)) then begin
      FileOpenDialog1.DefaultFolder := ExtractFileDir(LText);
    end;
  end;
  FileOpenDialog1.FileTypes.Clear;
  with FileOpenDialog1.FileTypes.Add do begin
    DisplayName := 'exe t@C';
    FileMask    := 'UniExtract.exe';
  end;
  if not FileOpenDialog1.Execute then Exit;

  Edit1.Text := FileOpenDialog1.FileName;
end;

//=============================================================================
//  HTML Help Workshop  EXE pX̎w
//=============================================================================
procedure TMainForm.SpeedButton2Click(Sender: TObject);
var
  LText : string;
begin
  FileOpenDialog1.Options := [fdoForceFileSystem];
  LText := Trim(Edit2.Text);
  if LText <> '' then begin
    if DirectoryExists(ExtractFileDir(LText)) then begin
      FileOpenDialog1.DefaultFolder := ExtractFileDir(LText);
    end;
  end;
  FileOpenDialog1.FileTypes.Clear;
  with FileOpenDialog1.FileTypes.Add do begin
    DisplayName := 'exe t@C';
    FileMask    := 'hhw.exe';
  end;
  if not FileOpenDialog1.Execute then Exit;

  Edit2.Text := FileOpenDialog1.FileName;
end;

//=============================================================================
//  wv}V  EXE pX̎w
//=============================================================================
procedure TMainForm.SpeedButton3Click(Sender: TObject);
var
  LTempPath : string;
begin
  FileOpenDialog1.Options := [fdoForceFileSystem];

  LTempPath := GetRelatedFullExePath('.XHP');
  if LTempPath = '' then begin
    LTempPath := GetHMachineExePathfromVirtualStore;
  end;
  FileOpenDialog1.DefaultFolder := ExtractFileDir(LTempPath);

  FileOpenDialog1.FileTypes.Clear;
  with FileOpenDialog1.FileTypes.Add do begin
    DisplayName := 'exe t@C';
    FileMask    := 'HHDesigner.exe';
  end;
  if not FileOpenDialog1.Execute then Exit;

  Edit3.Text := FileOpenDialog1.FileName;
end;

//=============================================================================
//  ϊ WinHelp  HLP t@C̎w
//=============================================================================
procedure TMainForm.SpeedButton4Click(Sender: TObject);
var
  LText : string;
begin
  FileOpenDialog1.Options := [fdoForceFileSystem];
  FileOpenDialog1.DefaultFolder := ExtractFileDir(Trim(Edit4.Text));
  FileOpenDialog1.FileTypes.Clear;
  with FileOpenDialog1.FileTypes.Add do begin
    DisplayName := 'hlp t@C';
    FileMask    := '*.hlp';
  end;

  if FileOpenDialog1.Execute then begin
    LText := FileOpenDialog1.FileName;
    if LText <> Trim(Edit4.Text) then begin
      Edit4.Text := FileOpenDialog1.FileName;
    end;
  end;
end;

//=============================================================================
//  TCYsƂ
//=============================================================================
procedure TMainForm.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Resize := False;
end;

//=============================================================================
//  {vÕEFuy[W\
//=============================================================================
procedure TMainForm.Panel1Click(Sender: TObject);
var
  Lurl : string;
begin
  Lurl := 'http://mrxray.on.coocan.jp/Delphi/Others/Win32HLP2ChmHLP.htm';
  RunExeFile(0, Lurl, '', '', False, True);
end;

//=============================================================================
//  V[gJbgo
//=============================================================================
procedure TMainForm.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
var
  LShortCut : TShortCut;
  LMsgText  : string;
  LExtXHP   : string;
  LExtXHC   : string;
begin
  LShortCut := ShortCut(Msg.CharCode, KeyDataToShiftState(Msg.KeyData));

  if LShortCut = FShortCut then begin
    LMsgText := 'wv܂̊gqo^폜܂';
    if MessageBox(Handle, PChar(LMsgText), 'wv܂̊gqo^폜', MB_OKCANCEL or MB_ICONQUESTION) = IDOK then begin
      LExtXHP := 'XHP';
      LExtXHC := 'XHC';

      Button1.Enabled := False;
      Screen.Cursor := crHourGlass;

      if DeleteResistryFileExt(LExtXHP) then begin
        DeleteResistryFileExt(LExtXHC);
        MessageBox(Handle, 'gq̓o^폜܂', '', MB_ICONINFORMATION);
      end else begin
        MessageBox(Handle, ' gq͓o^Ă܂', '', MB_ICONWARNING);
      end;

      Button1.Enabled := True;
      Screen.Cursor := crDefault;
    end;
    Handled := True;
  end;
end;

//=============================================================================
//  GNXv[̃hbNEAhEhbv
//=============================================================================
procedure TMainForm.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
var
  LBuffer   : array [0..MAX_PATH - 1] of Char;
  LText     : string;
  LFileName : string;
  LIndex    : Integer;
begin
  if Msg.message = WM_DROPFILES then begin
    try
      LIndex := 0;
      DragQueryFile(Msg.WParam, LIndex, LBuffer, MAX_PATH);
      LText := LBuffer;
      if (FindDragTarget(Msg.pt, False) = Edit1) then begin
        LFileName := UpperCase(ExtractFileName(LText));
        if TFile.Exists(LText) then begin
          if LFileName = UpperCase('UniExtract.exe') then begin
            Edit1.Text := LText;
          end;
        end;
      end else
      if (FindDragTarget(Msg.pt, False) = Edit2) then begin
        LFileName := UpperCase(ExtractFileName(LText));
        if TFile.Exists(LText) then begin
          if LFileName = UpperCase('hhw.exe') then begin
            Edit2.Text := LText;
          end;
        end;
      end else
      if (FindDragTarget(Msg.pt, False) = Edit3) then begin
        LFileName := UpperCase(ExtractFileName(LText));
        if TFile.Exists(LText) then begin
          if LFileName = UpperCase('HHDesigner.exe') then begin
            Edit3.Text := LText;
          end;
        end;
      end else
      if (FindDragTarget(Msg.pt, False) = Edit4) then begin
        LFileName := UpperCase(ExtractFileName(LText));
        if TFile.Exists(LText) then begin
          if ExtractFileExt(LFileName) = '.HLP' then begin
            Edit4.Text := LText;
          end;
        end;
      end;
    finally
      DragFinish(msg.WParam);
    end;
  end;
end;

//----------------------------------------------------------------------------
//  wv܂ INI t@C̃tpX擾
//  wv܂̓WXgɃCXg[͂Ȃ
//  ǗҌŎgpĂꍇ͊gq̓o^񂪃WXgɂ
//  (ǗҌŋNƊgqWXgɓo^悤ɂȂĂ)
//  ʃ[UŎgpĂ鎞̓o[`XgA INI t@Cɐݒe
//----------------------------------------------------------------------------
function TMainForm.GetHMachineIniFilePath(AExePath: string): string;
var
  LRelatePath : string;
  LVirtualDir : string;
  LOption     : TSearchOption;
  LFilesList  : TStringDynArray;
begin
  Result := '';

  LRelatePath := UpperCase(GetRelatedFullExePath('.XHP'));
  if UpperCase(AExePath) = LRelatePath then begin
    Result := ChangeFileExt(AExePath, '.ini');
    Exit;
  end;

  LVirtualDir := GetEnvironmentPath('%LOCALAPPDATA%\VirtualStore');
  if LVirtualDir = '' then Exit;

  LOption    := TSearchOption.soAllDirectories;
  LFilesList := TDirectory.GetFiles(LVirtualDir, 'HHDesigner.ini', LOption);
  if Length(LFilesList) = 1 then begin
    Result := LFilesList[0];
  end;

  // t@C̉z𖳌ɂĂꍇ̑΍􏈗
  if (Result = '') and FileExists(ChangeFileExt(AExePath,'.ini')) then begin
    Result := ChangeFileExt(AExePath,'.ini');
  end;
end;

//-----------------------------------------------------------------------------
//  zꂽt@Cwv܂ EXE ̃tpX擾
//  wv܂ʃ[UŎgpĂꍇ
//  zꂽt@C (o[`XgA  INI t@Cɐݒe
//   INI t@C̃tpX EXE ̏ꏊ𐄑
//-----------------------------------------------------------------------------
function TMainForm.GetHMachineExePathfromVirtualStore: string;
var
  LVirtualDir  : string;
  LOption      : TSearchOption;
  LFilesList   : TStringDynArray;
  LFilePath    : string;
  LSystemDrive : string;
begin
  Result := '';

  LVirtualDir := GetEnvironmentPath('%LOCALAPPDATA%\VirtualStore');

  LOption    := TSearchOption.soAllDirectories;
  LFilesList := TDirectory.GetFiles(LVirtualDir, 'HHDesigner.ini', LOption);
  if Length(LFilesList) = 1 then begin
    LSystemDrive := TDirectory.GetDirectoryRoot(LFilesList[0]);
    LFilePath := StringReplace(LFilesList[0], LVirtualDir + '\', '', [rfIgnoreCase]);
    Result := ChangeFileExt(LSystemDrive + LFilePath, '.exe');
  end;
end;

//----------------------------------------------------------------------------
//  w肵 HLP t@C̒
//  CNT  TOC t@CɖڎACe̋Lq邩ׂ
//  ȂΈ̒l󕶎ɂ
//  TOC t@CLȏꍇ ACntPath  TOC t@C̃pXԂ
//  ߂l͖ڎACe̐
//----------------------------------------------------------------------------
function TMainForm.CheckItemsCount(var ACntPath: string; ATocPath: string): Integer;
var
  LCntItemList : TStringList;
  LTempText    : string;
  LCntItemCnt  : Integer;
  LTocItemCnt  : Integer;
  LIndex       : Integer;
begin
  LCntItemCnt := 0;
  LTocItemCnt := 0;

  LCntItemList  := TStringList.Create;
  try
    if ACntPath <> '' then begin
      LCntItemList.LoadFromFile(ACntPath);
      for LIndex := LCntItemList.Count - 1 downto 0 do begin
        LTempText := Trim(LCntItemList[LIndex]);
        if Length(LTempText) < 3 then begin
          LCntItemList.Delete(LIndex);
        end else
        if not (CharInSet(LTempText[1], ['1'..'9'])) then begin
          LCntItemList.Delete(LIndex);
        end;
      end;
      LCntItemCnt := LCntItemList.Count;
      if LCntItemCnt = 0 then ACntPath := '';
    end;

    if ATocPath <> '' then begin
      LCntItemList.LoadFromFile(ATocPath);
      for LIndex := LCntItemList.Count - 1 downto 0 do begin
        LTempText := Trim(LCntItemList[LIndex]);
        if Length(LTempText) < 3 then begin
          LCntItemList.Delete(LIndex);
        end else
        if not (CharInSet(LTempText[1],['1'..'9'])) then begin
          LCntItemList.Delete(LIndex);
        end;
      end;
      LTocItemCnt := LCntItemList.Count;
      if LTocItemCnt = 0 then ATocPath := '';
    end;
  finally
    FreeAndNil(LCntItemList);
  end;
  if ACntPath = '' then ACntPath := ATocPath;
  Result := Max(LCntItemCnt, LTocItemCnt);
end;


//-----------------------------------------------------------------------------
//  Charset ̒l̕ϊp
//  HTML Help Workshop  RTF  HTML R[h𐶐鎞
//  </TITLE> ̈ꕔ邱ƂD̑΍܂
//-----------------------------------------------------------------------------
function TMainForm.ChangeCharSetETC(ADir, AOldValue, ANewValue: string): Integer;
var
  LOption    : TSearchOption;
  LFilePath  : string;
  LFilesList : TStringDynArray;
  LCodeList  : TStringList;
  LFileIdx   : Integer;
  LIndex    : Integer;
  LTempText : string;
begin
  Result := 0;

  LOption    := TSearchOption.soAllDirectories;
  LFilesList := TDirectory.GetFiles(ADir, '*.HTM', LOption);

  ProgressBar1.Style    := pbstNormal;
  ProgressBar1.Position := 0;
  ProgressBar1.Max := Length(LFilesList) - 1;

  LCodeList := TStringList.Create;
  try
    for LFileIdx := 0 to Length(LFilesList) - 1 do begin
      LFilePath := LFilesList[LFileIdx];
      if FileExists(LFilePath) then begin
        LCodeList.LoadFromFile(LFilePath);

        for LIndex := 0 to LCodeList.Count - 1 do begin
          LTempText := Trim((LCodeList[LIndex]));
          if LTempText = '' then Continue;
          if LTempText = '</HEAD>' then Break;

          if ContainsText(LTempText, AOldValue) then begin
            LCodeList[LIndex] := ReplaceText(LTempText, AOldValue, ANewValue);
          end;
          if UpperCase(LeftStr(LTempText, 7)) = '<TITLE>' then begin
            if UpperCase(RightStr(LTempText, 8)) <> '</TITLE>' then begin
              LTempText := Trim(Copy(LTempText, 8, Length(LTempText) - 16));
              LCodeList[LIndex] := '<TITLE>' + LTempText + '</TITLE>';
            end;
            Break;
          end;
        end;
        LCodeList.SaveToFile(LFilePath);
        Inc(Result);
      end;
      ProgressBar1.Position := LFileIdx;
      Application.ProcessMessages;
    end;
  finally
    FreeAndNil(LCodeList);
  end;
  ProgressBar1.Position := ProgressBar1.Max;
end;

//----------------------------------------------------------------------------
//  HTML Help Workshop  hhc t@C̃R[hOŐ
//  e HLP wv̏ɑΉ邽߂̑Ή
//----------------------------------------------------------------------------
function TMainForm.Create_hhcFile(AHtmlDir, ACntFilePath: string; var AOriginItemCnt: Integer;
  var AItemCnt: Integer; var AHeaderCnt: Integer; ADupeList: TStringList): Boolean;

  //---------------------------------------------------------------------------
  function GetKeywordText(ACodeList: TStringList): string;
  var
    LTagText  : string;
    LTextLen  : Integer;
    LTempText : string;
    LIndex    : Integer;
    LTextPos  : Integer;
  begin
    Result := '';
    LTagText := '<PARAM NAME="Keyword" VALUE="';
    LTextLen := Length(LTagText);

    for LIndex := 0 to ACodeList.Count - 1 do begin
      LTempText := Trim((ACodeList[LIndex]));
      if LTempText = '' then Continue;
      if LTempText = '</BODY>' then Break;

      LTextPos := Pos(LTagText, LTempText);
      if LTextPos > 0 then begin
        LTempText := Copy(LTempText, LTextPos, Length(LTempText));
        LTextPos  := Pos('">', LTempText);
        Result    := Copy(LTempText, LTextLen + 1, LTextPos - LTextLen - 1);
        Break;
      end;
    end;
  end;
  //---------------------------------------------------------------------------

  function GetTitleTagText(ACodeList: TStringList): string;
  var
    LIndex    : Integer;
    LTempText : string;
  begin
    Result := '';
    for LIndex := 0 to ACodeList.Count - 1 do begin
      LTempText := Trim((ACodeList[LIndex]));
      if LTempText = '' then Continue;
      if LTempText = '</HEAD>' then Break;
      if UpperCase(LeftStr(LTempText, 7)) = '<TITLE>' then begin
        if UpperCase(RightStr(LTempText, 8)) = '</TITLE>' then begin
          Result := Copy(LTempText, 8, Length(LTempText) - 15);
          Break;
        end;
      end;
    end;
  end;
  //---------------------------------------------------------------------------
  function GetTitleHrefText(ACodeList: TStringList; AText: string): string;
  var
    LText     : string;
    LTextLen  : Integer;
    LIndex    : Integer;
    LTempText : string;
    LPos1     : Integer;
  begin
    Result := '';
    LText    := '<A HREF="';
    LTextLen := Length(LText);

    for LIndex := 0 to ACodeList.Count - 1 do begin
      LTempText := Trim((ACodeList[LIndex]));
      if LTempText = '' then Continue;
      if LTempText = '</BODY>' then Break;
      if ContainsText(LTempText, AText) then begin
        LPos1 := Pos(LText, LTempText);
        if LPos1 > 0 then begin
          LTempText := Copy(LTempText, LPos1, Length(LTempText));
          LPos1  := Pos('">', LTempText);
          Result := Copy(LTempText, LTextLen + 1, LPos1 - LTextLen - 1);
          Break;
        end;
      end;
    end;
  end;
  //---------------------------------------------------------------------------

var
  LHtmlList      : TList<TStringList>;
  LFilesList     : TStringDynArray;
  LCntItemList   : TStringList;
  LSplitArray    : TArray<string>;
  LhhcCode       : TStringList;
  LHtmlCode      : TStringList;
  LSearchOption  : TSearchOption;
  LFilePath      : string;
  LFileName      : string;
  LNewFilePath   : string;
  LNewFileName   : string;
  LPageNumber    : Integer;
  LTempText      : string;
  LTabStr        : string;
  LCntLevelList  : array of integer;
  LCntTextList   : TStringList;
  LCntNameList   : TStringList;
  LLeveCnt       : Integer;
  LRefFileName   : string;
  LFindFlag      : Boolean;
  LFindFileIndex : Integer;
  LCntIndex      : Integer;
  LFileIdx       : Integer;
  LItemTextList  : TStringList;
  LDupeItemList  : TStringList;
  LnoGetItemList : TStringList;
  LEncoding      : TEncoding;
begin
  LCntItemList   := TStringList.Create;
  LCntTextList   := TStringList.Create;
  LCntNameList   := TStringList.Create;
  LhhcCode       := TStringList.Create;
  LItemTextList  := TStringList.Create;
  LDupeItemList  := TStringList.Create;
  LnoGetItemList := TStringList.Create;
  try
    LCntItemList.LoadFromFile(ACntFilePath);
    for LCntIndex := LCntItemList.Count - 1 downto 0 do begin
      LTempText := Trim(LCntItemList[LCntIndex]);
      if Length(LTempText) < 3 then begin
        LCntItemList.Delete(LCntIndex);
      end else
      if not CharInSet(LTempText[1], ['1'..'9']) then begin
        LCntItemList.Delete(LCntIndex);
      end;
    end;
    AOriginItemCnt := LCntItemList.Count;
    SetLength(LCntLevelList, LCntItemList.Count);
    if LCntItemList.Count < 1 then Exit;

    for LCntIndex := 0 to LCntItemList.Count - 1 do begin
      LTempText := Trim(LCntItemList[LCntIndex]);
      LCntLevelList[LCntIndex] := SysUtils.StrToInt(LTempText[1]);
      LTempText := Copy(LTempText, 2, Length(LTempText));

      LSplitArray := LTempText.Split(['=']);
      LCntTextList.Add(Trim(LSplitArray[0]));
      if Length(LSplitArray) >= 2 then begin
        LCntNameList.Add(Trim(LSplitArray[1]));
      end else begin
        LCntNameList.Add('');
      end;
    end;

    AItemCnt    := 0;
    AHeaderCnt  := 0;
    LPageNumber := 0;
    ProgressBar1.Max := LCntTextList.Count;

    LSearchOption := TSearchOption.soAllDirectories;
    LFilesList := TDirectory.GetFiles(AHtmlDir, '*.HTM', LSearchOption);
    LHtmlList := TList<TStringList>.Create;

    for LFileIdx := 0 to Length(LFilesList) - 1 do begin
      LFilePath := LFilesList[LFileIdx];
      LHtmlList.Add(TStringList.Create);
      LHtmlList[LFileIdx].LoadFromFile(LFilePath);
      Application.ProcessMessages;
    end;

    LhhcCode.Add('<HTML>');
    LhhcCode.Add('<!--Sitemap 1.0-->');
    LhhcCode.Add('<OBJECT type="text/site properties">');
    LhhcCode.Add('</OBJECT>');
    LhhcCode.Add('<UL>');

   //--------------------------
    ProgressBar1.Position := 0;
    ProgressBar1.Max := LCntTextList.Count - 1;


    for LCntIndex := 0 to LCntTextList.Count - 1 do begin

      if LCntIndex > 0 then begin
        if (LCntLevelList[LCntIndex] > LCntLevelList[LCntIndex - 1]) then begin
          LTabStr := DupeString( #$09, LCntLevelList[LCntIndex] - 1);
          LhhcCode.Add(LTabStr + '<UL>');
        end;
      end;

      if LCntNameList[LCntIndex] = '' then begin
        Inc(AHeaderCnt);

        LTabStr := DupeString( #$09, LCntLevelList[LCntIndex]);
        LhhcCode.Add(LTabStr + '<LI><OBJECT type="text/sitemap">');
        LhhcCode.Add(LTabStr + #$09 + '<param name="Name" value="' + LCntTextList[LCntIndex] + '">');
        LhhcCode.Add(LTabStr + #$09 + '<param name="Local" value="">');
        LhhcCode.Add(LTabStr + #$09 + '</OBJECT>');
      end else begin
        LFindFlag := False;
        LFindFileIndex := -1;

        for LFileIdx := 0 to Length(LFilesList) - 1 do begin
          LFilePath := LFilesList[LFileIdx];
          LHtmlCode := LHtmlList[LFileIdx];

          if ContainsText(LHtmlCode.Text, '<A NAME="' + LCntNameList[LCntIndex] + '"></A>') then begin
            LFindFlag := True;
            LFindFileIndex := LFileIdx;
            break;
          end;
          Application.ProcessMessages;
        end;

        if not LFindFlag then begin
          for LFileIdx := 0 to Length(LFilesList) - 1 do begin
            LFilePath := LFilesList[LFileIdx];
            LTempText := LCntTextList[LCntIndex];
            LHtmlCode := LHtmlList[LFileIdx];
            if UpperCase(LTempText) = UpperCase(GetTitleTagText(LHtmlCode)) then begin
              LFindFlag := True;
              LFindFileIndex := LFileIdx;
            end else begin
              if UpperCase(LTempText) = UpperCase(GetKeywordText(LHtmlCode)) then begin
                LFindFlag := True;
                LFindFileIndex := LFileIdx;
              end;
            end;
            if LFindFlag then begin
              if LItemTextList.IndexOf(LTempText) < 0 then begin
                LItemTextList.Add(LTempText);
              end else begin
                LDupeItemList.Add(LTempText);
              end;
              LFindFlag := True;
              LFindFileIndex := LFileIdx;
              break;
            end;
            Application.ProcessMessages;
          end;
        end;

        if not LFindFlag then begin
          for LFileIdx := 0 to Length(LFilesList) - 1 do begin
            LFilePath := LFilesList[LFileIdx];
            LHtmlCode := LHtmlList[LFileIdx];
            LRefFileName := GetTitleHrefText(LHtmlCode, LCntTextList[LCntIndex]);

            if LRefFileName <> '' then begin
              LFindFlag := True;
              LFindFileIndex := LFileIdx;
              Break;
            end;
            Application.ProcessMessages;
          end;
        end;

        if not LFindFlag then begin
          LnoGetItemList.Add(LCntTextList[LCntIndex]);
          Continue;
        end else begin
          LFileName    := ExtractFileName(LFilePath);
          LNewFileName := FormatFloat('00000000', LPageNumber + 1) + '.htm';
          LNewFilePath := ExtractFilePath(LFilePath) + LNewFileName;
          if System.Masks.MatchesMask(LFileName, '[0-9][0-9][0-9]*.htm')  then begin
            // 1 ̃y[W𕡐̖ڎACeŎgpĂꍇ
            // ʂ̃y[W(t@C)ɂ悤ȋC
            // C̓IWi̐ݒ𑸏dĉȂƂɂ
          end else begin
            LFilesList[LFindFileIndex] := LNewFilePath;
            for LFileIdx := 0 to Length(LFilesList) - 1 do begin
              LHtmlCode := LHtmlList[LFileIdx];
              LHtmlList[LFileIdx].Text := ReplaceText(LHtmlCode.Text, LFileName, LNewFileName);
              Application.ProcessMessages;
            end;
            LFileName := LNewFileName;
//
            Inc(LPageNumber);
          end;
          LTabStr := DupeString( #$09, LCntLevelList[LCntIndex]);

          LhhcCode.Add(LTabStr + '<LI><OBJECT type="text/sitemap">');
          LhhcCode.Add(LTabStr + #$09 + '<param name="Name" value="' + LCntTextList[LCntIndex] + '">');
          LhhcCode.Add(LTabStr + #$09 + '<param name="Local" value="html/' + LFileName + '">');
          LhhcCode.Add(LTabStr + #$09 + '</OBJECT>');
          LhhcCode.Add(LTabStr + #$09 + '<A HREF="html/' + LFileName + '">' + LCntTextList[LCntIndex] + '</A><BR>');
        end;
      end;

      if LCntIndex < (LCntTextList.Count - 2) then begin
        LLeveCnt := LCntLevelList[LCntIndex] - LCntLevelList[LCntIndex + 1];
      end else
      if LCntIndex = (LCntTextList.Count - 1) then begin
        LLeveCnt := LCntLevelList[LCntIndex] - 2;
      end;
      if LLeveCnt >= 1 then begin
        while True do begin
          if LLeveCnt = 0 then Break;
          LTabStr := DupeString( #$09, LCntLevelList[LCntIndex] + LLeveCnt - 2);
          LhhcCode.Add(LTabStr + '</UL>');
          Dec(LLeveCnt);
        end;
      end;

      Inc(AItemCnt);

      Application.ProcessMessages;
      Sleep(10);
      ProgressBar1.Position := LCntIndex;
    end;
    //--------------------------

    LCntIndex := LCntTextList.Count - 1;
    if LCntLevelList[LCntIndex] >= 2 then begin
      LTabStr := DupeString( #$09, LCntLevelList[LCntIndex - 1] - 1);
      LhhcCode.Add(LTabStr + '</UL>');
    end;

    LhhcCode.Add('</UL>');
    LhhcCode.Add('</HTML>');

    LFileName := ChangeFileExt(ExtractFileName(ACntFilePath), '.hhc');
    LFilePath := TPath.Combine(ExtractFileDir(AHtmlDir), LFileName);
    if FHMachineExePath = '' then begin
      LhhcCode.SaveToFile(LFilePath);
    end else begin
      // EUC-JP(CP20932)
      LEncoding := TEncoding.GetEncoding(20932);
      try
        LhhcCode.SaveToFile(LFilePath, LEncoding);
      finally
        FreeAndNil(LEncoding);
      end;
    end;


    // ύX HTML R[hۑ
    // t@C̕ύX
    for LFileIdx := 0 to Length(LFilesList) - 1 do begin
      LHtmlList[LFileIdx].SaveToFile(LFilesList[LFileIdx]);
      Application.ProcessMessages;
    end;

    ADupeList.Clear;
    if LnoGetItemList.Count >= 1 then begin
      ADupeList.Add('Y HTML t@C݂ȂڎACe');
      ADupeList.Add('');
      ADupeList.Add(LnoGetItemList.Text);
      ADupeList.Add('');
    end;
    if LDupeItemList.Count >= 1 then begin
      ProgressBar1.Position := 0;
      ProgressBar1.Max := (LDupeItemList.Count - 1) * (Length(LFilesList) - 1);

      ADupeList.Add(' HTML t@CԈĂ邩mȂڎACe');
      ADupeList.Add('');
      for LCntIndex := 0 to LDupeItemList.Count - 1 do begin
        if ADupeList.IndexOf(LDupeItemList[LCntIndex]) >= 0 then Continue;

        LCntItemList.Clear;
        for LFileIdx := 0 to Length(LFilesList) - 1 do begin
          LFilePath := LFilesList[LFileIdx];
          LHtmlCode := LHtmlList[LFileIdx];
          if LDupeItemList[LCntIndex] = GetTitleTagText(LHtmlCode) then begin
            LCntItemList.Add('  ' + ExtractFileName(LFilePath));
          end;
          ProgressBar1.Position := LCntIndex * LFileIdx;
          Application.ProcessMessages;
        end;
        if LCntItemList.Count >= 2 then begin
          ADupeList.Add(LDupeItemList[LCntIndex]);
          ADupeList.Add(LCntItemList.Text);
        end;
        ProgressBar1.Position := LCntIndex;
        Application.ProcessMessages;
      end;
    end;

    if ADupeList.Count >= 2 then begin
      LHtmlCode.Clear;
      LHtmlCode.Add( ExtractFileName(ACntFilePath) + ' ɂڎACȅ̌');
      LHtmlCode.Add('');
      LHtmlCode.Add('\ HTML t@CsmȖڎACẽXgł');
      LHtmlCode.Add('̌ۂ CNT ܂ TOC t@C̋LqɂĔ܂');
      LHtmlCode.Add( DupeString('-',77));
      ADupeList.Insert(0, LHtmlCode.Text);
    end;
  finally
    for LFileIdx := 0 to Length(LFilesList) - 1 do begin
      LHtmlList[LFileIdx].Free;
    end;
    FreeAndNil(LHtmlList);

    FreeAndNil(LCntItemList);
    FreeAndNil(LCntTextList);
    FreeAndNil(LCntNameList);
    FreeAndNil(LhhcCode);
    FreeAndNil(LItemTextList);
    FreeAndNil(LDupeItemList);
    FreeAndNil(LnoGetItemList);
  end;
  ProgressBar1.Position := ProgressBar1.Max;
end;

//----------------------------------------------------------------------------
//  HTML Help Workshop  hhk t@C̃R[hOŐ
//  L[[h̐ HTML Help Workshop, wv܂̋@\gp
//----------------------------------------------------------------------------
function TMainForm.Create_hhkFile(AHtmlDir: string; ACntFilePath: string;
  AFullKeywords: Boolean): Integer;

  //---------------------------------------------------------------------------
  procedure GetKeywordText(ACodeList: TStringList; AKeywordList: TStringList);
  var
    LTagText  : string;
    LTextLen  : Integer;
    LIndex    : Integer;
    LTempText : string;
    LTextPos  : Integer;
  begin
    AKeywordList.Clear;
    LTagText := '<PARAM NAME="Keyword" VALUE="';
    LTextLen := Length(LTagText);

    for LIndex := 0 to ACodeList.Count - 1 do begin
      LTempText := Trim((ACodeList[LIndex]));
      if LTempText = '' then Continue;
      if LTempText = '</BODY>' then Break;

      LTextPos := Pos(LTagText, LTempText);
      if LTextPos > 0 then begin
        LTempText := Copy(LTempText, LTextPos, Length(LTempText));
        LTextPos := Pos('">', LTempText);
        AKeywordList.Add(Copy(LTempText, LTextLen + 1, LTextPos - LTextLen - 1));
      end;
    end;
  end;
  //---------------------------------------------------------------------------

var
  LSearchOption : TSearchOption;
  LFilesList    : TStringDynArray;
  LFilePath     : string;
  LhhkCode      : TStringList;
  LKeywordList  : TStringList;
  LHtmlCode     : TStringList;
  LFileName     : string;
  LTempText     : string;
  LFileIdx      : Integer;
  LIndex        : Integer;
begin
  Result := 0;

  LhhkCode := TStringList.Create;
  try
    LhhkCode.Add('<HTML>');
    LhhkCode.Add('<!-- Sitemap 1.0 -->');
    LhhkCode.Add('<OBJECT type="text/site properties">');
    LhhkCode.Add('</OBJECT>');
    LhhkCode.Add('<UL>');

    if AFullKeywords then begin
      LSearchOption := TSearchOption.soAllDirectories;
      LFilesList := TDirectory.GetFiles(AHtmlDir, '*.HTM', LSearchOption);

      ProgressBar1.Position := 0;
      ProgressBar1.Max := Length(LFilesList) - 1;

      LHtmlCode := TStringList.Create;
      LKeywordList := TStringList.Create;
      try
        for LFileIdx := 0 to Length(LFilesList) - 1 do begin
          LFilePath := LFilesList[LFileIdx];
          LHtmlCode.LoadFromFile(LFilePath);
          GetKeywordText(LHtmlCode, LKeywordList);
          for LIndex := 0 to LKeywordList.Count - 1 do begin
            LTempText := LKeywordList[LIndex];
            LFileName := ExtractFileName(LFilePath);
            LhhkCode.Add(#$09 + '<LI> <OBJECT type="text/sitemap">');
            LhhkCode.Add(#$09 + #$09 + '<param name="Keyword" value="' + LTempText + '">');
            LhhkCode.Add(#$09 + #$09 + '<param name="Name" value="' + LTempText + '">');
            LhhkCode.Add(#$09 + #$09 + '<param name="Local" value="html/' + LFileName + '">');
            LhhkCode.Add(#$09 + #$09 + '</OBJECT>');

            Inc(Result);
          end;
          ProgressBar1.Position := LFileIdx;
          Application.ProcessMessages;
        end;
      finally
        FreeAndNil(LKeywordList);
        FreeAndNil(LHtmlCode);
      end;
    end;
    LhhkCode.Add('</UL></HTML>');

    LFileName := ChangeFileExt(ExtractFileName(ACntFilePath), '.hhk');
    LFilePath := TPath.Combine(ExtractFileDir(AHtmlDir), LFileName);
    LhhkCode.SaveToFile(LFilePath);
  finally
    FreeAndNil(LhhkCode);
  end;
  ProgressBar1.Position := ProgressBar1.Max;
end;

//----------------------------------------------------------------------------
//  wv܂̃vWFNgt@C XHP ̍쐬
//  wv܂݂̌̐ݒ͍lȂ
//
//  wv܂̓RpC̎ɁC̃vWFNg̓eɊÂ
//  HTML Help Workshop ̃vWFNgt@C HHP 쐬
//
//  (ύX)Ȃ TIniFile ܂ TMemIniFile gp
//  ʒuƃTCY̐ݒ肪LȂ͖̂{̏\̎̂
//  tpX CHM t@C̈ʒuƃTCY Windows Ǘ
//----------------------------------------------------------------------------
function TMainForm.CreateHelpMachineXHP(AXHPPath: string): Boolean;
var
  LXHPCode    : TStringList;
  LProjName   : string;
  LXHCPath    : string;
  LProjDir    : string;
  LLocaleArr  : array [0..LOCALE_NAME_MAX_LENGTH - 1] of Char;
  LLocaleText : string;
begin
  Result := True;

  LProjName := ChangeFileExt(ExtractFileName(AXHPPath), '');
  LXHCPath  := ChangeFileExt(AXHPPath, '.XHC');
  LProjDir  := ExtractFileDir(AXHPPath);
  if FileExists(AXHPPath) then Result := False;

  FillChar(LLocaleArr, SizeOf(LLocaleArr), #0);
  GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_ILANGUAGE, LLocaleArr, Length(LLocaleArr));
  LLocaleText := LLocaleArr;
  FillChar(LLocaleArr, SizeOf(LLocaleArr), #0);
  GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SENGLANGUAGE, LLocaleArr, Length(LLocaleArr));
  LLocaleText := LLocaleText + ' ' + string(LLocaleArr);

  LXHPCode := TStringList.Create;
  try
    LXHPCode.Add('[XHP]');
    LXHPCode.Add('Version=249');
    LXHPCode.Add('PDir=' + LProjDir);
    LXHPCode.Add('Name=' + LProjName);
    LXHPCode.Add('XHP=' + AXHPPath);
    LXHPCode.Add('XHC=' + LXHCPath);
    LXHPCode.Add('HelpName=' + LProjName);
    LXHPCode.Add('FileName=' + LProjName + '.chm');
    LXHPCode.Add('NodeIcon=1');
    LXHPCode.Add('CSS=');
    LXHPCode.Add('UseCSS=0');
    LXHPCode.Add('KeepPos=1');
    LXHPCode.Add('Topmost=0');
    LXHPCode.Add('PosX=200');
    LXHPCode.Add('PosY=200');
    LXHPCode.Add('Width=600');
    LXHPCode.Add('Height=400');
    LXHPCode.Add('FrameWidth=200');
    LXHPCode.Add('BTView=1');
    LXHPCode.Add('BTBack=1');
    LXHPCode.Add('BTNext=1');
    LXHPCode.Add('BTOption=0');
    LXHPCode.Add('BTPrint=0');
    LXHPCode.Add('BTRefresh=0');
    LXHPCode.Add('BTStop=0');
    LXHPCode.Add('BTUp=0');
    LXHPCode.Add('BTDown=0');
    LXHPCode.Add('BTSync=0');
    LXHPCode.Add('BTHomeURL=0');
    LXHPCode.Add('BTJump1=0');
    LXHPCode.Add('BTJump2=0');
    LXHPCode.Add('FullTextSearch=1');
    LXHPCode.Add('TabSearch=1');
    LXHPCode.Add('TabFavorite=0');
    LXHPCode.Add('TabKeyword=1');
    LXHPCode.Add('Visible=0');
    LXHPCode.Add('Edge=0');
    LXHPCode.Add('BToc=0');
    LXHPCode.Add('Maximize=0');
    LXHPCode.Add('NodeSquare=1');
    LXHPCode.Add('NodeLines=1');
    LXHPCode.Add('OneClick=0');
    LXHPCode.Add('BTFont=0');
    LXHPCode.Add('Default=');
    LXHPCode.Add('FontName=MS UI Gothic');
    LXHPCode.Add('FontSize=10');
    LXHPCode.Add('LangNum=14');
    LXHPCode.Add('LangStr=' + LLocaleText);
    LXHPCode.Add('AutoHTML=');
    LXHPCode.Add('AutoHEAD=');
    LXHPCode.Add('HideTxt=0');
    LXHPCode.Add('HideFirst=0');
    LXHPCode.Add('ConvSJIS=1');
    LXHPCode.Add('ConvKillJS=0');
    LXHPCode.Add('URLFilter=0');
    LXHPCode.Add('SetCompleteDestOW=0');
    LXHPCode.Add('SetCompleteDestPathOW=');

    LXHPCode.SaveToFile(AXHPPath);
  finally
    FreeAndNil(LXHPCode);
  end;
end;

//----------------------------------------------------------------------------
//  HTML Help Workshop ̃vWFNgt@C̍쐬
//  _^̒l 0, 1 ł͂Ȃ Yues, No ̕
//  [WINDOWS] ZbVȂƃ{^ނ̐ݒ肪łȂ̂Œǉ
//  {vOł͖ڎACeɑ HTML t@CύXĂ
//  ̂ [FILES] ZbV̒lOŐݒ@
//
//  \̈ʒuƃTCY͖{̍ŏ̎L
//  tpX CHM t@C̈ʒuƃTCY Windows Ǘ
//
//  HHP ̓eɂĂ͗ႦΈȉQ
//  http://www.helpware.net/FAR/help/dlg_hhpedit_sec.htm
//  https://www-user.tu-chemnitz.de/~heha/viewchm.php/hs/chmspec.chm/hhp.html
//----------------------------------------------------------------------------
function TMainForm.CreateHHWorkshopHHP(AProjPath: string): Boolean;
var
  LHelpTitle  : string;
  LFileName   : string;
  LItemCnt    : Integer;
  LTextList   : TStringList;
  LCommaList  : TStringList;
  LWinText    : string;
  LHtmlPath   : string;
  LOption     : TSearchOption;
  LFilesList  : TStringDynArray;
  LFilePath   : string;
  LLocaleArr  : array [0..LOCALE_NAME_MAX_LENGTH - 1] of Char;
  LLocaleText : string;
  LIndex      : Integer;
begin
  Result := False;
  if not FileExists(AProjPath) then Exit;

  SetLength(TrueBoolStrs, 1);
  SetLength(FalseBoolStrs, 1);
  TrueBoolStrs[0]  := 'Yes';
  FalseBoolStrs[0] := 'No';

  FillChar(LLocaleArr, SizeOf(LLocaleArr), #0);
  GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_ILANGUAGE, LLocaleArr, Length(LLocaleArr));
  LLocaleText   := LLocaleArr;
  LLocaleText := '0x' + LLocaleText;
  FillChar(LLocaleArr, SizeOf(LLocaleArr), #0);
  GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_SLANGUAGE, LLocaleArr, Length(LLocaleArr));
  LLocaleText := LLocaleText + ' ' + string(LLocaleArr);

  LFileName  := ChangeFileExt(ExtractFileName(AProjPath), '');
  LHelpTitle := LFileName + ' wv';

  LTextList := TStringList.Create;
  try
    LTextList.Add('[OPTIONS]');
    LTextList.Add('Full-text search=' + BoolToStr(True, True));
    LTextList.Add('Auto Index=' + BoolToStr(FHMachineExePath <> '', True));
    LTextList.Add('Compatibility=1.1 or later');
    LTextList.Add('Compiled file=' + LFileName + '.chm');
    LTextList.Add('Contents file=' +  LFileName + '.hhc');
    LTextList.Add('Default topic=');
    LTextList.Add('Display compile progress=' + BoolToStr(False, True));
    LTextList.Add('Index file=' + LFileName + '.hhk');
    LTextList.Add('Language=' + LLocaleText);
    LTextList.Add('Title=' + LHelpTitle);
    LTextList.Add('Default Window=WND1');

    LCommaList := TStringList.Create;
    try
      LItemCnt := 20;
      LCommaList.CommaText := DupeString(',', LItemCnt - 1);

      LCommaList[0]  := AnsiQuotedStr(LHelpTitle, '"');
      LCommaList[1]  := AnsiQuotedStr(LFileName + '.hhc', '"');
      LCommaList[2]  := AnsiQuotedStr(LFileName + '.hhk', '"');
      LCommaList[3]  := AnsiQuotedStr('', '"');
      LCommaList[9]  := '0x60720';
      LCommaList[10] := '200';
      LCommaList[11] := '0xE';
      LCommaList[12] := '[200,200,800,600]';
      LCommaList[13] := '0x0';
      LCommaList[14] := '0x0';
      LCommaList[LCommaList.Count - 1] := '0';

      LWinText := LCommaList[0];
      for LIndex := 1 to LCommaList.Count -1 do begin
        LWinText := LWinText  + ',' + LCommaList[LIndex];
      end;
      LTextList.Add('');
      LTextList.Add('[WINDOWS]');
      LTextList.Add('WND1=' + LWinText);
    finally
      FreeAndNil(LCommaList);
    end;

    LTextList.Add('');
    LTextList.Add('[FILES]');

    LHtmlPath  := ExtractFilePath(AProjPath);
    LOption    := TSearchOption.soAllDirectories;
    LFilesList := TDirectory.GetFiles(LHtmlPath + 'html', '*.htm', LOption);
    for LIndex := 0 to Length(LFilesList) - 1 do begin
      LFilePath := ReplaceText(LFilesList[LIndex], LHtmlPath, '');
      LTextList.Add(LFilePath);
    end;

    LTextList.SaveToFile(AProjPath);
  finally
    FreeAndNil(LTextList);
  end;

  Result := True;

  TrueBoolStrs[0]  := 'True';
  FalseBoolStrs[0] := 'False';
end;

//----------------------------------------------------------------------------
//  HPJ  RTF  HTML Help Workshop  HTML t@C𐶐
//  HTML Help Workshop (hhw.exe) ̓R}hC삪Ȃ̂ŉu
//  ̃_CAO\܂Ń^COKv
//
//  NX #32770 ̃_CAO̐e hhw.exe ł邪gbvx̃EBhE
//   hhw.exe ̎qEBhÊł͂Ȃ EnumWindows Ō
//  ̎qEBhE̒̎w ID l̃Rg[đ삷
//
//  FWorkshopWnd, FTargetID ̓O[oϐ
//----------------------------------------------------------------------------
function TMainForm.RemotHHCWindow(AHPJPath, AHHPPath: string): Boolean;
var
  LCmdLine : string;
  LCtrlWnd : HWND;
begin
  Result := False;

  LCmdLine := Chr(VK_MENU) + 'FN';
  SendCtrlKeys(FWorkshopWnd, LCmdLine);
  Application.ProcessMessages;
  //-----------------------------------------

  Sleep(100);
  FTargetID := 1;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, BM_CLICK, 0, 0);
  //-----------------------------------------

  Sleep(100);
  FTargetID := $452;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  if SendMessage(LCtrlWnd, BM_GETCHECK, 0, 0) = BST_UNCHECKED then begin
    SendMessage(LCtrlWnd, BM_SETCHECK, BST_CHECKED, 0);
  end;

  FTargetID := $3024;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, BM_CLICK, 0, 0);
  //-----------------------------------------

  Sleep(100);
  FTargetID := $47D;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, WM_SETTEXT, 0, LPARAM(PChar(AHPJPath)));

  FTargetID := $3EB;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, WM_SETTEXT, 0, LPARAM(PChar(AHHPPath)));

  FTargetID := $3024;
  LCtrlWnd   := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, BM_CLICK, 0, 0);
  //-----------------------------------------

  Sleep(100);
  FTargetID := $3025;
  LCtrlWnd  := 0;
  EnumWindows(@EnumWindowsProcEx, LPARAM(@LCtrlWnd));
  if LCtrlWnd = 0 then Exit;
  SendMessage(LCtrlWnd, BM_CLICK, 0, 0);

  Result := True;
end;

//-----------------------------------------------------------------------------
//  EnumWindows̃R[obN֐
//  wv܂p
//  _CAÕEBhEnh擾
//  FHMachineWnd ̓O[oϐ
//-----------------------------------------------------------------------------
function EnumWindowsProcHMachine(hWindow: HWND; lPalam: PNativeInt): Boolean; stdcall;
begin
  Result := True;

  if IsWindowVisible(hWindow) then begin
    if '#32770' = GetWindowClassNameStr(hWindow) then begin
      if FHMachineWnd = GetWindowLong(hWindow, GWL_HWNDPARENT) then begin
        lPalam^ := hWindow;
        Result  := False;
      end;
    end;
  end;
end;

//----------------------------------------------------------------------------
//  wv܂̉u
//  vWFNgJ hhc t@C荞ŕۑčēxvWFNgJ
//  ăRpC
//  FHMachineWnd ̓O[oϐ
//----------------------------------------------------------------------------
function TMainForm.RemotHelpMachine(AXHPPath: string; AhhcPath: string): Boolean;

  //--------------------------------------------------------------------------
  function SearchControlAndSet(hWindow: HWND; AFilePath: string): Boolean;
  var
    LLoopCnt  : Integer;
    LDlgWnd   : HWND;
    LChildWnd : HWND;
    LCtrlWnd  : HWND;
  begin
    Result := False;

    LDlgWnd := 0;
    LLoopCnt := 0;
    while True do begin
      EnumWindows(@EnumWindowsProcHMachine, LPARAM(@LDlgWnd));
      if LDlgWnd > 0 then begin
        if AFilePath = '' then begin
          ShowWindow(LDlgWnd, SW_HIDE);
          PostMessage(LDlgWnd, WM_CLOSE, 0, 0);
          Application.ProcessMessages;
          Result := True;
          Exit;
        end else begin
          SetPositionSize(LDlgWnd, False, True);
        end;;
        Break;
      end;
      if LLoopCnt > 500 then Break;
      Inc(LLoopCnt);
      Application.ProcessMessages;
      Sleep(10);
    end;
    if LDlgWnd = 0 then Exit;

    LChildWnd := FindWindowEx(LDlgWnd, 0, 'ComboBoxEx32', nil);
    if LChildWnd > 0 then begin
      LChildWnd := FindWindowEx(LChildWnd, 0, 'ComboBox', nil);
      if LChildWnd > 0 then begin
        LChildWnd := FindWindowEx(LChildWnd, 0, 'Edit', nil);
        if LChildWnd > 0 then begin
          SendMessage(LChildWnd, WM_SETTEXT, 0, LPARAM(PChar(AFilePath)));
          Sleep(100);
          LCtrlWnd := GetDlgItem(LDlgWnd, 1);
          SetPositionSize(LDlgWnd, True, True);
          SendMessage(LCtrlWnd, BM_CLICK, 0, 0);
          Result := True;
        end;
      end;
    end;
    if (AFilePath <> '') then begin
      SetPositionSize(LDlgWnd, True, True);
    end;
  end;
  //--------------------------------------------------------------------------

var
  LCmdLine : string;
begin
  Result := False;
  
  Sleep(100);
  while True do begin
    FHMachineWnd := FindWindow(nil, 'wv܂');
    if FHMachineWnd <> 0 then Break;
    Application.ProcessMessages;
    Sleep(10);
  end;

  Sleep(100);
  LCmdLine := Chr(VK_MENU) + 'PW';
  SendCtrlKeys(FHMachineWnd, LCmdLine);
  Application.ProcessMessages;

  Sleep(100);
  if not SearchControlAndSet(FHMachineWnd, AhhcPath) then Exit;
  //-----------------------------------------

  if not SearchControlAndSet(FHMachineWnd, '') then Exit;
  //-----------------------------------------

  Sleep(100);
  LCmdLine := Chr(VK_CONTROL) + 'S';
  SendCtrlKeys(FHMachineWnd, LCmdLine);
  Application.ProcessMessages;
  //-----------------------------------------

  Sleep(100);
  LCmdLine := Chr(VK_CONTROL) + 'O';
  SendCtrlKeys(FHMachineWnd, LCmdLine);
  Application.ProcessMessages;

  Sleep(100);
  if not SearchControlAndSet(FHMachineWnd, AXHPPath) then Exit;
  //-----------------------------------------

  Sleep(100);
  LCmdLine := Chr(VK_CONTROL) + 'G';
  SendCtrlKeys(FHMachineWnd, LCmdLine);
  Application.ProcessMessages;

  Result := True;
end;

//-----------------------------------------------------------------------------
//  32rbgWindows64rbgWindows𒲂ׂ֐
//  64rbgłWindows̏ꍇTrueԂ
//-----------------------------------------------------------------------------
function Is64bitWindows: Boolean;
var
  Wow64Proc : function(hProcess: THandle; var Wow64: BOOL): BOOL stdcall;
  RetFlag   : LongBool;
begin
  @Wow64Proc := GetProcAddress(GetModuleHandle('Kernel32.dll'), 'IsWow64Process');
  if @Wow64Proc <> nil then begin
    Wow64Proc(GetCurrentProcess, RetFlag);

    if SizeOf(THandle) = 4 then begin
      Result := RetFlag;
    end else
    if SizeOf(THandle) = 8 then begin
      Result := True;
    end;
  end else begin
    //Windows XP64rbgł
    Result := CheckWin32Version(5, 2);
  end;
end;

//----------------------------------------------------------------------------
//  w肵gqɊ֘AÂst@C̃tpX擾֐
//  wv܂̌op
//
//  AssocQueryString̎gpɂusesShLwApiKv
//  OleCheckWin32CheckĂƗOoĂ
//  OleCheckWin32Check̎gpɂuuseComObjKv
//----------------------------------------------------------------------------
function GetRelatedFullExePath(ExtName: string): string;
var
  LBuffer : array [0..MAX_PAtH-1] of Char;
  LdwOut  : DWORD;
begin
  Result := '';

  FillChar(LBuffer, SizeOf(LBuffer), #0);
  LdwOut := MAX_PATH;
  try
    OleCheck(WinApi.ShLwApi.AssocQueryString(ASSOCF_NOTRUNCATE,
                                      ASSOCSTR_EXECUTABLE,
                                      PChar(ExtName),
                                      nil,
                                      LBuffer,
                                      @LdwOut));
    Result := LBuffer;

    if Length(Result) = 0 then begin
      Result := '';
    end else begin
      if Pos('" ', Result) > 0 then begin
        Result := Copy(Result, 1, Pos('" ', Result) + 1);
      end;
    end;
  except
  end;
  // ȉ̕wv܂pɂȂĂ
  if UpperCase(ExtractFileName(Result)) <> UpperCase('HHDesigner.exe') then begin
    Result := '';
  end;

end;

//-----------------------------------------------------------------------------
//  ARegKeỹTuL[̍ڂ
//  ̃AvCXg[Ă΂̃fBNgԂ
//-----------------------------------------------------------------------------
function CheckInstAppDir(AReg: TRegistry; ARegKey: string; AppName: string): string;
var
  LKeyNameList : TStringList;
  LKeyEachApp  : string;
  LDisplayName : string;
  LUninstStr   : string;
  LLoopCnt     : Integer;
begin
  Result := '';

  LKeyNameList := TStringList.Create;
  try
    if not AReg.OpenKey(ARegKey, False) then exit;
    // ARegKeyKw̃L[̈ꗗ擾
    AReg.GetKeyNames(LKeyNameList);

    AReg.CloseKey;
    // L[̈ꗗ̊eL[̍ڂ𒲂ׂ
    for LLoopCnt := 0 to LKeyNameList.Count - 1 do begin
      try
        LKeyEachApp := ARegKey + PathDelim + LKeyNameList[LLoopCnt];
        if AReg.OpenKey(LKeyEachApp, False) then begin
          if not AReg.ValueExists('DisplayName') then Continue;
          if not AReg.ValueExists('UninstallString') then Continue;

          LDisplayName := AReg.ReadString('DisplayName');
          if ContainsText(LDisplayName, '(KB') then Continue;
          LUninstStr := AReg.ReadString('UninstallString');

          if ContainsText(LDisplayName, AppName) then begin
            Result := ExtractFileDir(LUninstStr);
            break;
          end;
        end;
      finally
        AReg.CloseKey;
      end;
    end;
  finally
    FreeAndNil(LKeyNameList);
  end;
end;

//-----------------------------------------------------------------------------
//  Ŏw肷AṽAṽCXg[fBNg擾
//  32 bit Avp
//-----------------------------------------------------------------------------
function GetInstalledAppDir(AppNameStr: string): string;
var
  LRegistry  : TRegistry;
  LKeyUnInst : String;
begin
  LRegistry := TRegistry.Create;
  try
    if Is64bitWindows then begin
      // 64rbgWindows̏ꍇ
      LRegistry.Access  := KEY_READ or KEY_WOW64_32KEY;
      LRegistry.RootKey := HKEY_LOCAL_MACHINE;
      LKeyUnInst := 'Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall';
      Result := CheckInstAppDir(LRegistry, LKeyUnInst, AppNameStr);
      LRegistry.CloseKey;
    end else begin
      // 32rbgWindows̏ꍇ
      LRegistry.Access  := KEY_READ;
      LRegistry.RootKey := HKEY_LOCAL_MACHINE;
      LKeyUnInst := 'Software\Microsoft\Windows\CurrentVersion\Uninstall';
      Result := CheckInstAppDir(LRegistry, LKeyUnInst, AppNameStr);
    end;
    LRegistry.CloseKey;
  finally
    FreeAndNil(LRegistry);
  end;
end;

//-----------------------------------------------------------------------------
//  wR}h̎s
//  HTML Help Workshop  SW_HIDE ł͑łȂ
//  SW_HIDE ̎ O SetPositionSize ֐ňʒuƃTCYw肵Ă\
//-----------------------------------------------------------------------------
function RunExeFile(hWnd: HWND; AFile: string; AParameters: string;
   Verb: string; IsWaitQuit: Boolean; ISHHWShow: Boolean): Cardinal;
var
  LInfo : TShellExecuteInfo;
  LRet  : Cardinal;
  LFlag : Cardinal;
begin
  if ISHHWShow then begin
    LFlag := SW_SHOW;
  end else begin
    LFlag := SW_HIDE;
  end;

  FillChar(LInfo, SizeOf(LInfo), 0);
  LInfo.cbSize := SizeOf(LInfo);
  LInfo.Wnd    := hWnd;

  LInfo.fMask  := SEE_MASK_FLAG_DDEWAIT or
                  SEE_MASK_FLAG_NO_UI   or
                  SEE_MASK_NOCLOSEPROCESS;
  LInfo.lpVerb := PChar(Verb);

  LInfo.lpFile       := PChar(AFile);
  LInfo.lpParameters := PChar(AParameters);
  LInfo.nShow        := LFlag;

  ShellExecuteEx(@LInfo);

  //ShellExecuteEx͐hInstApp33ȏ̒lԂ
  if LInfo.hInstApp >= 33 then begin
    if IsWaitQuit then begin
      while WaitForSingleObject(LInfo.hProcess, 100) = WAIT_TIMEOUT do begin
        Application.ProcessMessages;
      end;
    end else begin
      repeat
        LRet := WaitForInputIdle(LInfo.hProcess, 50);
        Application.ProcessMessages;
      until LRet <> WAIT_TIMEOUT;
    end;
    CloseHandle(LInfo.hProcess);
  end;

  Result := LInfo.hInstApp;
end;

//----------------------------------------------------------------------------
//  EBhËʒuƃTCŶݒ
//  \ĂύX̂ł͂Ȃ TWindowPlacement ɐݒ肵Ă\
//  EXE Nɂ͍ŏ܂ HIDE ɂĂ
//  TWindowPlacement gp邱̕@́C\̃EBhEɑ΂Ă͖
//  \̃EBhËʒuTCYύXɂ SetWindowPos gp 
//----------------------------------------------------------------------------
procedure SetPositionSize(AWnd: HWND; IsRestore: Boolean; IsHIDE: Boolean);
var
  LOpenPlace : TWindowPlacement;
begin
  if IsRestore then begin
    if IsHIDE then begin
      FOriginPlace.showCmd := SW_HIDE;
    end;
    SetWindowPlacement(AWnd, @FOriginPlace);
    Exit;
  end;

  FOriginPlace.length := SizeOf(TWindowPlacement);
  LOpenPlace.length   := SizeOf(TWindowPlacement);
  GetWindowPlacement(AWnd, FOriginPlace);
  LOpenPlace := FOriginPlace;

  LOpenPlace.rcNormalPosition.Left := 7500;
  LOpenPlace.rcNormalPosition.Top  := 7500;
  LOpenPlace.showCmd := SW_SHOWNORMAL;
  SetWindowPlacement(AWnd, @LOpenPlace);
end;

//-----------------------------------------------------------------------------
//  𑗐M
//  ̃Av̕ҏWEBhEւ̑Mɂp\ȃR[h
//-----------------------------------------------------------------------------
procedure SendCtrlKeys(hWindow: HWND; ACmdStr: string);
var
  i : Integer;
  LCode : Cardinal;
begin
  //hWindow͑MEBhẼEBhEnh
  SetForegroundWindow(hWindow);
  for i := 1 to Length(ACmdStr) do begin
    LCode := Ord(ACmdStr[i]);
    keybd_event(LCode, MapVirtualKey(LCode, 0), 0, 0);
  end;
  for i := Length(ACmdStr) downto 1 do begin
    LCode := Ord(ACmdStr[i]);
    keybd_event(LCode, MapVirtualKey(LCode, 0), KEYEVENTF_KEYUP, 0);
  end;
end;

//-----------------------------------------------------------------------------
//  EnumWindows̃R[obN֐
//  FWorkshopWnd ̓O[oϐ
//-----------------------------------------------------------------------------
function EnumWindowsProcEx(hWindow: HWND; lPalam: PNativeInt): Boolean; stdcall;
var
  LDlgWnd : HWND;
begin
  Result := True;

  if IsWindowVisible(hWindow) then begin
    if '#32770' = GetWindowClassNameStr(hWindow) then begin
      if FWorkshopWnd = GetWindowLong(hWindow, GWL_HWNDPARENT) then begin
        LDlgWnd := 0;
        EnumChildWindows(hWindow, @EnumChildWindowsProcEx, LPARAM(@LDlgWnd));
        if LDlgWnd <> 0 then begin
          lPalam^ := LDlgWnd;
          Result  := False;
        end;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  EnumChildWindows ̃R[obN֐
//  eEBhEKw̎w iD l̃Rg[̃EBhEnho
//  FTargetID ̓O[oϐ
//-----------------------------------------------------------------------------
function EnumChildWindowsProcEx(hWindow: HWND; lPalam: PNativeInt): Boolean; stdcall;
begin
  Result := True;

  if IsWindowVisible(hWindow) then begin
    if FTargetID = GetWindowLong(hWindow, GWL_ID) then begin
      lPalam^ := hWindow;
      Result  := False;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  EBhẼNX擾֐
//-----------------------------------------------------------------------------
function GetWindowClassNameStr(hWindow: HWND): String;
var
  Buffer : array[0..MAX_PATH-1] of Char;
  Len    : Integer;
begin
  FillChar(Buffer, SizeOf(Buffer), #0);
  Len := GetClassName(hWindow, Buffer, Length(Buffer));
  if Len > 0 then begin
    Result := Buffer;
  end else begin
    Result := '';
  end;
end;

//-----------------------------------------------------------------------------
//  ϐ̎pX擾֐
//-----------------------------------------------------------------------------
function GetEnvironmentPath(AEnvName: string): string;
var
    LDstChar : array [0..MAX_PATH - 1] of Char;
begin
  FillChar(LDstChar,SizeOf(LDstChar), #0);
  ExpandEnvironmentStrings(PChar(AEnvName), LDstChar, MAX_PATH);
  Result := LDstChar;
end;

//-----------------------------------------------------------------------------
//  o^gq֌W̃L[WXg폜
//  ǗҌł̎sKv
//
//  RegistFileExt o^ς݂̊gq(.͕tȂ)
//
//  TRegistry̎gpɂusesRegistryKv
//-----------------------------------------------------------------------------
function DeleteResistryFileExt(RegistFileExt: String): Boolean;

  //---------------------------------------------------------------------------
  //  t@C̊gqAvP[V̎QƖ̒l擾
  //  AppFileExy : t@C̊gq(.͕tȂ)
  //---------------------------------------------------------------------------
  function GetAppProgIDName(AppFileExt: string): string;
  var
    LRegistry : TRegistry;
  begin
    Result := '';
    LRegistry := TRegistry.Create(KEY_READ);
    try
      LRegistry.RootKey := HKEY_CLASSES_ROOT;

      //Ygqo^ĂȂΎ擾łȂ
      if LRegistry.OpenKeyReadOnly('\.' + AppFileExt) then begin
        Result := LRegistry.ReadString('');
      end;
    finally
      FreeAndNil(LRegistry);
    end;
  end;
  //---------------------------------------------------------------------------

var
  LRegistAppReff  : string;
  LRegAppFileExt  : string;
  LRegAppProgID   : string;
  LRegExplorerExt : string;
  LCmdLine        : TplCommandRedirect;
  LCmdStr         : string;
begin
  LRegistAppReff := GetAppProgIDName(RegistFileExt);

  if (RegistFileExt = '') or (RegistFileExt = '.') or
      (LRegistAppReff = '') then begin
    Result := False;
  end else begin

    LRegAppFileExt  := 'HKEY_CLASSES_ROOT\' + '.' + RegistFileExt;
    LRegAppProgID   := 'HKEY_CLASSES_ROOT\' + LRegistAppReff;
    LRegExplorerExt := 'HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\'
                    + 'Explorer\FileExts\' + '.' + RegistFileExt;

    //Ώۂ̃L[̗LɊւ炸폜̃R[hs
    LCmdLine := TplCommandRedirect.Create;
    try
      //ɂ͋L^ĂȂꍇ
      LCmdStr := 'Cmd.exe /k reg delete ' + LRegExplorerExt + ' /f';
      LCmdLine.GrabStdOutText(LCmdStr);

      LCmdStr := 'Cmd.exe /k reg delete ' + LRegAppProgID + ' /f';
      LCmdLine.GrabStdOutText(LCmdStr);

      LCmdStr := 'Cmd.exe /k reg delete ' + LRegAppFileExt + ' /f';
      LCmdLine.GrabStdOutText(LCmdStr);

      //VXeɕύXʒm
      SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_FLUSH, nil, nil);

      Result := True;
    finally
      FreeAndNil(LCmdLine);
    end;
  end;
end;

end.
